diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/lte/model/lte-harq-phy.cc ns-3.40/src/lte/model/lte-harq-phy.cc
--- ns-3.39/src/lte/model/lte-harq-phy.cc	2023-07-05 14:23:48.013428000 -0700
+++ ns-3.40/src/lte/model/lte-harq-phy.cc	2023-09-27 13:30:37.818839600 -0700
@@ -53,8 +53,7 @@
     NS_LOG_FUNCTION(this);
 
     // left shift UL HARQ buffers
-    std::map<uint16_t, std::vector<HarqProcessInfoList_t>>::iterator it;
-    for (it = m_miUlHarqProcessesInfoMap.begin(); it != m_miUlHarqProcessesInfoMap.end(); it++)
+    for (auto it = m_miUlHarqProcessesInfoMap.begin(); it != m_miUlHarqProcessesInfoMap.end(); it++)
     {
         (*it).second.erase((*it).second.begin());
         HarqProcessInfoList_t h;
@@ -87,8 +86,7 @@
 {
     NS_LOG_FUNCTION(this << rnti);
 
-    std::map<uint16_t, std::vector<HarqProcessInfoList_t>>::iterator it;
-    it = m_miUlHarqProcessesInfoMap.find(rnti);
+    auto it = m_miUlHarqProcessesInfoMap.find(rnti);
     NS_ASSERT_MSG(it != m_miUlHarqProcessesInfoMap.end(), " Does not find MI for RNTI");
     HarqProcessInfoList_t list = (*it).second.at(0);
     double mi = 0.0;
@@ -103,8 +101,7 @@
 LteHarqPhy::GetHarqProcessInfoUl(uint16_t rnti, uint8_t harqProcId)
 {
     NS_LOG_FUNCTION(this << rnti << (uint16_t)harqProcId);
-    std::map<uint16_t, std::vector<HarqProcessInfoList_t>>::iterator it;
-    it = m_miUlHarqProcessesInfoMap.find(rnti);
+    auto it = m_miUlHarqProcessesInfoMap.find(rnti);
     if (it == m_miUlHarqProcessesInfoMap.end())
     {
         // new entry
@@ -157,8 +154,7 @@
                                       uint16_t codeBytes)
 {
     NS_LOG_FUNCTION(this << rnti << mi);
-    std::map<uint16_t, std::vector<HarqProcessInfoList_t>>::iterator it;
-    it = m_miUlHarqProcessesInfoMap.find(rnti);
+    auto it = m_miUlHarqProcessesInfoMap.find(rnti);
     if (it == m_miUlHarqProcessesInfoMap.end())
     {
         // new entry
@@ -199,8 +195,7 @@
 LteHarqPhy::ResetUlHarqProcessStatus(uint16_t rnti, uint8_t id)
 {
     NS_LOG_FUNCTION(this << rnti << (uint16_t)id);
-    std::map<uint16_t, std::vector<HarqProcessInfoList_t>>::iterator it;
-    it = m_miUlHarqProcessesInfoMap.find(rnti);
+    auto it = m_miUlHarqProcessesInfoMap.find(rnti);
     if (it == m_miUlHarqProcessesInfoMap.end())
     {
         // new entry
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/lte/model/lte-interference.cc ns-3.40/src/lte/model/lte-interference.cc
--- ns-3.39/src/lte/model/lte-interference.cc	2023-07-05 14:23:48.013428000 -0700
+++ ns-3.40/src/lte/model/lte-interference.cc	2023-09-27 13:30:37.818839600 -0700
@@ -72,24 +72,17 @@
         m_rxSignal = rxPsd->Copy();
         m_lastChangeTime = Now();
         m_receiving = true;
-        for (std::list<Ptr<LteChunkProcessor>>::const_iterator it =
-                 m_rsPowerChunkProcessorList.begin();
-             it != m_rsPowerChunkProcessorList.end();
+        for (auto it = m_rsPowerChunkProcessorList.begin(); it != m_rsPowerChunkProcessorList.end();
              ++it)
         {
             (*it)->Start();
         }
-        for (std::list<Ptr<LteChunkProcessor>>::const_iterator it =
-                 m_interfChunkProcessorList.begin();
-             it != m_interfChunkProcessorList.end();
+        for (auto it = m_interfChunkProcessorList.begin(); it != m_interfChunkProcessorList.end();
              ++it)
         {
             (*it)->Start();
         }
-        for (std::list<Ptr<LteChunkProcessor>>::const_iterator it =
-                 m_sinrChunkProcessorList.begin();
-             it != m_sinrChunkProcessorList.end();
-             ++it)
+        for (auto it = m_sinrChunkProcessorList.begin(); it != m_sinrChunkProcessorList.end(); ++it)
         {
             (*it)->Start();
         }
@@ -117,24 +110,17 @@
     {
         ConditionallyEvaluateChunk();
         m_receiving = false;
-        for (std::list<Ptr<LteChunkProcessor>>::const_iterator it =
-                 m_rsPowerChunkProcessorList.begin();
-             it != m_rsPowerChunkProcessorList.end();
+        for (auto it = m_rsPowerChunkProcessorList.begin(); it != m_rsPowerChunkProcessorList.end();
              ++it)
         {
             (*it)->End();
         }
-        for (std::list<Ptr<LteChunkProcessor>>::const_iterator it =
-                 m_interfChunkProcessorList.begin();
-             it != m_interfChunkProcessorList.end();
+        for (auto it = m_interfChunkProcessorList.begin(); it != m_interfChunkProcessorList.end();
              ++it)
         {
             (*it)->End();
         }
-        for (std::list<Ptr<LteChunkProcessor>>::const_iterator it =
-                 m_sinrChunkProcessorList.begin();
-             it != m_sinrChunkProcessorList.end();
-             ++it)
+        for (auto it = m_sinrChunkProcessorList.begin(); it != m_sinrChunkProcessorList.end(); ++it)
         {
             (*it)->End();
         }
@@ -201,23 +187,16 @@
 
         SpectrumValue sinr = (*m_rxSignal) / interf;
         Time duration = Now() - m_lastChangeTime;
-        for (std::list<Ptr<LteChunkProcessor>>::const_iterator it =
-                 m_sinrChunkProcessorList.begin();
-             it != m_sinrChunkProcessorList.end();
-             ++it)
+        for (auto it = m_sinrChunkProcessorList.begin(); it != m_sinrChunkProcessorList.end(); ++it)
         {
             (*it)->EvaluateChunk(sinr, duration);
         }
-        for (std::list<Ptr<LteChunkProcessor>>::const_iterator it =
-                 m_interfChunkProcessorList.begin();
-             it != m_interfChunkProcessorList.end();
+        for (auto it = m_interfChunkProcessorList.begin(); it != m_interfChunkProcessorList.end();
              ++it)
         {
             (*it)->EvaluateChunk(interf, duration);
         }
-        for (std::list<Ptr<LteChunkProcessor>>::const_iterator it =
-                 m_rsPowerChunkProcessorList.begin();
-             it != m_rsPowerChunkProcessorList.end();
+        for (auto it = m_rsPowerChunkProcessorList.begin(); it != m_rsPowerChunkProcessorList.end();
              ++it)
         {
             (*it)->EvaluateChunk(*m_rxSignal, duration);
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/lte/model/lte-mi-error-model.cc ns-3.40/src/lte/model/lte-mi-error-model.cc
--- ns-3.39/src/lte/model/lte-mi-error-model.cc	2023-07-05 14:23:48.013428000 -0700
+++ ns-3.40/src/lte/model/lte-mi-error-model.cc	2023-09-27 13:30:37.818839600 -0700
@@ -1042,7 +1042,7 @@
     NS_LOG_FUNCTION(sinr);
     double MI;
     double MIsum = 0.0;
-    Values::const_iterator sinrIt = sinr.ConstValuesBegin();
+    auto sinrIt = sinr.ConstValuesBegin();
     uint16_t rb = 0;
     NS_ASSERT(sinrIt != sinr.ConstValuesEnd());
     while (sinrIt != sinr.ConstValuesEnd())
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/lte/model/lte-pdcp.cc ns-3.40/src/lte/model/lte-pdcp.cc
--- ns-3.39/src/lte/model/lte-pdcp.cc	2023-07-05 14:23:48.013428000 -0700
+++ ns-3.40/src/lte/model/lte-pdcp.cc	2023-09-27 13:30:37.822839500 -0700
@@ -191,8 +191,6 @@
     }
 
     pdcpHeader.SetDcBit(LtePdcpHeader::DATA_PDU);
-
-    NS_LOG_LOGIC("PDCP header: " << pdcpHeader);
     p->AddHeader(pdcpHeader);
     p->AddByteTag(pdcpTag, 1, pdcpHeader.GetSerializedSize());
 
@@ -203,6 +201,7 @@
     txParams.lcid = m_lcid;
     txParams.pdcpPdu = p;
 
+    NS_LOG_INFO("Transmitting PDCP PDU with header: " << pdcpHeader);
     m_rlcSapProvider->TransmitPdcpPdu(txParams);
 }
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/lte/model/lte-rlc-am.cc ns-3.40/src/lte/model/lte-rlc-am.cc
--- ns-3.39/src/lte/model/lte-rlc-am.cc	2023-07-05 14:23:48.013428000 -0700
+++ ns-3.40/src/lte/model/lte-rlc-am.cc	2023-09-27 13:30:37.822839500 -0700
@@ -238,7 +238,6 @@
                                                    << m_vrMs.GetValue());
         SequenceNumber10 sn;
         sn.SetModulusBase(m_vrR);
-        std::map<uint16_t, PduBuffer>::iterator pduIt;
         for (sn = m_vrR; sn < m_vrMs; sn++)
         {
             NS_LOG_LOGIC("SN = " << sn);
@@ -247,7 +246,7 @@
                 NS_LOG_LOGIC("Can't fit more NACKs in STATUS PDU");
                 break;
             }
-            pduIt = m_rxonBuffer.find(sn.GetValue());
+            auto pduIt = m_rxonBuffer.find(sn.GetValue());
             if (pduIt == m_rxonBuffer.end() || (!(pduIt->second.m_pduComplete)))
             {
                 NS_LOG_LOGIC("adding NACK_SN " << sn.GetValue());
@@ -258,7 +257,7 @@
         // 3GPP TS 36.322 section 6.2.2.1.4 ACK SN
         // find the  SN of the next not received RLC Data PDU
         // which is not reported as missing in the STATUS PDU.
-        pduIt = m_rxonBuffer.find(sn.GetValue());
+        auto pduIt = m_rxonBuffer.find(sn.GetValue());
         while ((sn < m_vrMs) && (pduIt != m_rxonBuffer.end()) && (pduIt->second.m_pduComplete))
         {
             NS_LOG_LOGIC("SN = " << sn << " < " << m_vrMs << " = " << (sn < m_vrMs));
@@ -660,8 +659,7 @@
 
     // Calculate FramingInfo flag according the status of the SDUs in the DataField
     uint8_t framingInfo = 0;
-    std::vector<Ptr<Packet>>::iterator it;
-    it = dataField.begin();
+    auto it = dataField.begin();
 
     // FIRST SEGMENT
     LteRlcSduStatusTag tag;
@@ -926,7 +924,7 @@
             //         - discard the duplicate byte segments.
             // note: re-segmentation of AMD PDU is currently not supported,
             // so we just check that the segment was not received before
-            std::map<uint16_t, PduBuffer>::iterator it = m_rxonBuffer.find(seqNumber.GetValue());
+            auto it = m_rxonBuffer.find(seqNumber.GetValue());
             if (it != m_rxonBuffer.end())
             {
                 NS_ASSERT(!it->second.m_byteSegments.empty());
@@ -959,7 +957,7 @@
         //     - update VR(MS) to the SN of the first AMD PDU with SN > current VR(MS) for
         //       which not all byte segments have been received;
 
-        std::map<uint16_t, PduBuffer>::iterator it = m_rxonBuffer.find(m_vrMs.GetValue());
+        auto it = m_rxonBuffer.find(m_vrMs.GetValue());
         if (it != m_rxonBuffer.end() && it->second.m_pduComplete)
         {
             int firstVrMs = m_vrMs.GetValue();
@@ -986,7 +984,7 @@
 
         if (seqNumber == m_vrR)
         {
-            std::map<uint16_t, PduBuffer>::iterator it = m_rxonBuffer.find(seqNumber.GetValue());
+            auto it = m_rxonBuffer.find(seqNumber.GetValue());
             if (it != m_rxonBuffer.end() && it->second.m_pduComplete)
             {
                 it = m_rxonBuffer.find(m_vrR.GetValue());
@@ -1243,15 +1241,19 @@
         }
     } while (extensionBit == 1);
 
-    std::list<Ptr<Packet>>::iterator it;
-
     // Current reassembling state
     if (m_reassemblingState == WAITING_S0_FULL)
+    {
         NS_LOG_LOGIC("Reassembling State = 'WAITING_S0_FULL'");
+    }
     else if (m_reassemblingState == WAITING_SI_SF)
+    {
         NS_LOG_LOGIC("Reassembling State = 'WAITING_SI_SF'");
+    }
     else
+    {
         NS_LOG_LOGIC("Reassembling State = Unknown state");
+    }
 
     // Received framing Info
     NS_LOG_LOGIC("Framing Info = " << (uint16_t)framingInfo);
@@ -1271,7 +1273,7 @@
                 /**
                  * Deliver one or multiple PDUs
                  */
-                for (it = m_sdusBuffer.begin(); it != m_sdusBuffer.end(); it++)
+                for (auto it = m_sdusBuffer.begin(); it != m_sdusBuffer.end(); it++)
                 {
                     m_rlcSapUser->ReceivePdcpPdu(*it);
                 }
@@ -1401,7 +1403,7 @@
                 /**
                  * Deliver one or multiple PDUs
                  */
-                for (it = m_sdusBuffer.begin(); it != m_sdusBuffer.end(); it++)
+                for (auto it = m_sdusBuffer.begin(); it != m_sdusBuffer.end(); it++)
                 {
                     m_rlcSapUser->ReceivePdcpPdu(*it);
                 }
@@ -1702,7 +1704,7 @@
 
     m_vrMs = m_vrX;
     int firstVrMs = m_vrMs.GetValue();
-    std::map<uint16_t, PduBuffer>::iterator it = m_rxonBuffer.find(m_vrMs.GetValue());
+    auto it = m_rxonBuffer.find(m_vrMs.GetValue());
     while (it != m_rxonBuffer.end() && it->second.m_pduComplete)
     {
         m_vrMs++;
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/lte/model/lte-rlc-am-header.cc ns-3.40/src/lte/model/lte-rlc-am-header.cc
--- ns-3.39/src/lte/model/lte-rlc-am-header.cc	2023-07-05 14:23:48.013428000 -0700
+++ ns-3.40/src/lte/model/lte-rlc-am-header.cc	2023-09-27 13:30:37.822839500 -0700
@@ -248,8 +248,7 @@
     NS_LOG_FUNCTION(this);
     NS_ASSERT_MSG(m_dataControlBit == CONTROL_PDU && m_controlPduType == LteRlcAmHeader::STATUS_PDU,
                   "method allowed only for STATUS PDUs");
-    for (std::list<int>::iterator nackIt = m_nackSnList.begin(); nackIt != m_nackSnList.end();
-         ++nackIt)
+    for (auto nackIt = m_nackSnList.begin(); nackIt != m_nackSnList.end(); ++nackIt)
     {
         if ((*nackIt) == nack.GetValue())
         {
@@ -301,9 +300,9 @@
 void
 LteRlcAmHeader::Print(std::ostream& os) const
 {
-    std::list<uint8_t>::const_iterator it1 = m_extensionBits.begin();
-    std::list<uint16_t>::const_iterator it2 = m_lengthIndicators.begin();
-    std::list<int>::const_iterator it3 = m_nackSnList.begin();
+    auto it1 = m_extensionBits.begin();
+    auto it2 = m_lengthIndicators.begin();
+    auto it3 = m_nackSnList.begin();
 
     os << "Len=" << m_headerLength;
     os << " D/C=" << (uint16_t)m_dataControlBit;
@@ -362,9 +361,9 @@
 {
     Buffer::Iterator i = start;
 
-    std::list<uint8_t>::const_iterator it1 = m_extensionBits.begin();
-    std::list<uint16_t>::const_iterator it2 = m_lengthIndicators.begin();
-    std::list<int>::const_iterator it3 = m_nackSnList.begin();
+    auto it1 = m_extensionBits.begin();
+    auto it2 = m_lengthIndicators.begin();
+    auto it3 = m_nackSnList.begin();
 
     if (m_dataControlBit == DATA_PDU)
     {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/lte/model/lte-rlc-header.cc ns-3.40/src/lte/model/lte-rlc-header.cc
--- ns-3.39/src/lte/model/lte-rlc-header.cc	2023-07-05 14:23:48.013428000 -0700
+++ ns-3.40/src/lte/model/lte-rlc-header.cc	2023-09-27 13:30:37.822839500 -0700
@@ -127,8 +127,8 @@
 void
 LteRlcHeader::Print(std::ostream& os) const
 {
-    std::list<uint8_t>::const_iterator it1 = m_extensionBits.begin();
-    std::list<uint16_t>::const_iterator it2 = m_lengthIndicators.begin();
+    auto it1 = m_extensionBits.begin();
+    auto it2 = m_lengthIndicators.begin();
 
     os << "Len=" << m_headerLength;
     os << " FI=" << (uint16_t)m_framingInfo;
@@ -168,8 +168,8 @@
 {
     Buffer::Iterator i = start;
 
-    std::list<uint8_t>::const_iterator it1 = m_extensionBits.begin();
-    std::list<uint16_t>::const_iterator it2 = m_lengthIndicators.begin();
+    auto it1 = m_extensionBits.begin();
+    auto it2 = m_lengthIndicators.begin();
 
     i.WriteU8(((m_framingInfo << 3) & 0x18) | (((*it1) << 2) & 0x04) |
               ((m_sequenceNumber.GetValue() >> 8) & 0x0003));
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.39/src/lte/model/lte-rlc-um.cc ns-3.40/src/lte/model/lte-rlc-um.cc
--- ns-3.39/src/lte/model/lte-rlc-um.cc	2023-07-05 14:23:48.013428000 -0700
+++ ns-3.40/src/lte/model/lte-rlc-um.cc	2023-09-27 13:30:37.822839500 -0700
@@ -105,7 +105,6 @@
 LteRlcUm::DoTransmitPdcpPdu(Ptr<Packet> p)
 {
     NS_LOG_FUNCTION(this << m_rnti << (uint32_t)m_lcid << p->GetSize());
-
     if (m_txBufferSize + p->GetSize() <= m_maxTxBufferSize)
     {
         if (m_enablePdcpDiscarding)
@@ -123,7 +122,7 @@
             NS_LOG_DEBUG("head of line delay in MS:" << headOfLineDelayInMs);
             if (headOfLineDelayInMs > discardTimerMs)
             {
-                NS_LOG_DEBUG("Tx HOL is higher than this packet can allow. RLC SDU discarded");
+                NS_LOG_INFO("Tx HOL is higher than this packet can allow. RLC SDU discarded");
                 NS_LOG_DEBUG("headOfLineDelayInMs    = " << headOfLineDelayInMs);
                 NS_LOG_DEBUG("m_packetDelayBudgetMs    = " << m_packetDelayBudgetMs);
                 NS_LOG_DEBUG("packet size     = " << p->GetSize());
@@ -135,8 +134,7 @@
         LteRlcSduStatusTag tag;
         tag.SetStatus(LteRlcSduStatusTag::FULL_SDU);
         p->AddPacketTag(tag);
-
-        NS_LOG_LOGIC("Tx Buffer: New packet added");
+        NS_LOG_INFO("Adding RLC SDU to Tx Buffer after adding LteRlcSduStatusTag: FULL_SDU");
         m_txBuffer.emplace_back(p, Simulator::Now());
         m_txBufferSize += p->GetSize();
         NS_LOG_LOGIC("NumOfBuffers = " << m_txBuffer.size());
@@ -145,7 +143,7 @@
     else
     {
         // Discard full RLC SDU
-        NS_LOG_LOGIC("TxBuffer is full. RLC SDU discarded");
+        NS_LOG_INFO("Tx Buffer is full. RLC SDU discarded");
         NS_LOG_LOGIC("MaxTxBufferSize = " << m_maxTxBufferSize);
         NS_LOG_LOGIC("txBufferSize    = " << m_txBufferSize);
         NS_LOG_LOGIC("packet size     = " << p->GetSize());
@@ -165,11 +163,15 @@
 LteRlcUm::DoNotifyTxOpportunity(LteMacSapUser::TxOpportunityParameters txOpParams)
 {
     NS_LOG_FUNCTION(this << m_rnti << (uint32_t)m_lcid << txOpParams.bytes);
+    NS_LOG_INFO("RLC layer is preparing data for the following Tx opportunity of "
+                << txOpParams.bytes << " bytes for RNTI=" << m_rnti << ", LCID=" << (uint32_t)m_lcid
+                << ", CCID=" << (uint32_t)txOpParams.componentCarrierId << ", HARQ ID="
+                << (uint32_t)txOpParams.harqId << ", MIMO Layer=" << (uint32_t)txOpParams.layer);
 
     if (txOpParams.bytes <= 2)
     {
         // Stingy MAC: Header fix part is 2 bytes, we need more bytes for the data
-        NS_LOG_LOGIC("TX opportunity too small = " << txOpParams.bytes);
+        NS_LOG_INFO("TX opportunity too small - Only " << txOpParams.bytes << " bytes");
         return;
     }
 
@@ -364,8 +366,7 @@
     rlcHeader.SetSequenceNumber(m_sequenceNumber++);
 
     // Build RLC PDU with DataField and Header
-    std::vector<Ptr<Packet>>::iterator it;
-    it = dataField.begin();
+    auto it = dataField.begin();
 
     uint8_t framingInfo = 0;
 
@@ -431,6 +432,7 @@
     params.harqProcessId = txOpParams.harqId;
     params.componentCarrierId = txOpParams.componentCarrierId;
 
+    NS_LOG_INFO("Forward RLC PDU to MAC Layer");
     m_macSapProvider->TransmitPdu(params);
 
     if (!m_txBuffer.empty())
@@ -557,11 +559,10 @@
     {
         NS_LOG_LOGIC("Reception buffer contains SN = " << m_vrUr);
 
-        std::map<uint16_t, Ptr<Packet>>::iterator it;
         uint16_t newVrUr;
         SequenceNumber10 oldVrUr = m_vrUr;
 
-        it = m_rxBuffer.find(m_vrUr.GetValue());
+        auto it = m_rxBuffer.find(m_vrUr.GetValue());
         newVrUr = (it->first) + 1;
         while (m_rxBuffer.count(newVrUr) > 0)
         {
@@ -693,15 +694,19 @@
         }
     } while (extensionBit == 1);
 
-    std::list<Ptr<Packet>>::iterator it;
-
     // Current reassembling state
     if (m_reassemblingState == WAITING_S0_FULL)
+    {
         NS_LOG_LOGIC("Reassembling State = 'WAITING_S0_FULL'");
+    }
     else if (m_reassemblingState == WAITING_SI_SF)
+    {
         NS_LOG_LOGIC("Reassembling State = 'WAITING_SI_SF'");
+    }
     else
+    {
         NS_LOG_LOGIC("Reassembling State = Unknown state");
+    }
 
     // Received framing Info
     NS_LOG_LOGIC("Framing Info = " << (uint16_t)framingInfo);
@@ -720,7 +725,7 @@
                 /**
                  * Deliver one or multiple PDUs
                  */
-                for (it = m_sdusBuffer.begin(); it != m_sdusBuffer.end(); it++)
+                for (auto it = m_sdusBuffer.begin(); it != m_sdusBuffer.end(); it++)
                 {
                     m_rlcSapUser->ReceivePdcpPdu(*it);
                 }
@@ -900,7 +905,7 @@
                 /**
                  * Deliver one or multiple PDUs
                  */
-                for (it = m_sdusBuffer.begin(); it != m_sdusBuffer.end(); it++)
+                for (auto it = m_sdusBuffer.begin(); it != m_sdusBuffer.end(); it++)
                 {
                     m_rlcSapUser->ReceivePdcpPdu(*it);
                 }
@@ -1119,8 +1124,7 @@
 {
     NS_LOG_LOGIC("Reassemble Outside Window");
 
-    std::map<uint16_t, Ptr<Packet>>::iterator it;
-    it = m_rxBuffer.begin();
+    auto it = m_rxBuffer.begin();
 
     while ((it != m_rxBuffer.end()) && !IsInsideReorderingWindow(SequenceNumber10(it->first)))
     {
@@ -1129,7 +1133,7 @@
         // Reassemble RLC SDUs and deliver the PDCP PDU to upper layer
         ReassembleAndDeliver(it->second);
 
-        std::map<uint16_t, Ptr<Packet>>::iterator it_tmp = it;
+        auto it_tmp = it;
         ++it;
         m_rxBuffer.erase(it_tmp);
     }
@@ -1145,15 +1149,13 @@
 {
     NS_LOG_LOGIC("Reassemble SN between " << lowSeqNumber << " and " << highSeqNumber);
 
-    std::map<uint16_t, Ptr<Packet>>::iterator it;
-
     SequenceNumber10 reassembleSn = lowSeqNumber;
     NS_LOG_LOGIC("reassembleSN = " << reassembleSn);
     NS_LOG_LOGIC("highSeqNumber = " << highSeqNumber);
     while (reassembleSn < highSeqNumber)
     {
         NS_LOG_LOGIC("reassembleSn < highSeqNumber");
-        it = m_rxBuffer.find(reassembleSn.GetValue());
+        auto it = m_rxBuffer.find(reassembleSn.GetValue());
         NS_LOG_LOGIC("it->first  = " << it->first);
         NS_LOG_LOGIC("it->second = " << it->second);
         if (it != m_rxBuffer.end())
@@ -1214,10 +1216,9 @@
     //    - start t-Reordering;
     //    - set VR(UX) to VR(UH).
 
-    std::map<uint16_t, Ptr<Packet>>::iterator it;
     SequenceNumber10 newVrUr = m_vrUx;
 
-    while ((it = m_rxBuffer.find(newVrUr.GetValue())) != m_rxBuffer.end())
+    while (m_rxBuffer.find(newVrUr.GetValue()) != m_rxBuffer.end())
     {
         newVrUr++;
     }
